/**********
This library is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the
Free Software Foundation; either version 2.1 of the License, or (at your
option) any later version. (See <http://www.gnu.org/copyleft/lesser.html>.)

This library is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
more details.

You should have received a copy of the GNU Lesser General Public License
along with this library; if not, write to the Free Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**********/
// "liveMedia"
// Copyright (c) 1996-2004 Live Networks, Inc.  All rights reserved.
// A 'ServerMediaSubsession' object that creates new, unicast, "RTPSink"s
// on demand, from a MPEG-2 Transport Stream file.
// Implementation

#include "MPEG2TSFileServerMediaSubsession.hh"
//#include "MPEG1or2AudioRTPSink.hh"
#include "SimpleRTPSink.hh"
#include "ByteStreamFileSource.hh"
#include "MPEG1or2AudioStreamFramer.hh"
#include "MPEG1or2VideoStreamFramer.hh"

MPEG2TSFileServerMediaSubsession*
MPEG2TSFileServerMediaSubsession::createNew(UsageEnvironment& env,
						  char const* fileName) {
  return new MPEG2TSFileServerMediaSubsession(env, fileName);
}

MPEG2TSFileServerMediaSubsession
::MPEG2TSFileServerMediaSubsession(UsageEnvironment& env,
					 char const* fileName)
  : FileServerMediaSubsession(env, fileName) {
}

MPEG2TSFileServerMediaSubsession
::~MPEG2TSFileServerMediaSubsession() {
}

FramedSource* MPEG2TSFileServerMediaSubsession
::createNewStreamSource(unsigned /*clientSessionId*/, unsigned& estBitrate) {
  estBitrate = 500; // kbps, estimate

#if 1
  ByteStreamFileSource* fileSource
    = ByteStreamFileSource::createNew(envir(), fFileName, 188, 600);
	return fileSource;
//  return ByteStreamFileSource::createNew(envir(), fFileName, 188, 600);
#else
  ByteStreamFileSource* fileSource
    = ByteStreamFileSource::createNew(envir(), fFileName, 188, 600);
  if (fileSource == NULL) return NULL;

//  return MPEG1or2AudioStreamFramer
//    ::createNew(envir(), fileSource);
  return MPEG1or2VideoStreamFramer
    ::createNew(envir(), fileSource, False, 5.0);
#endif
}

RTPSink* MPEG2TSFileServerMediaSubsession
::createNewRTPSink(Groupsock* rtpGroupsock,
		   unsigned char /*rtpPayloadTypeIfDynamic*/,
		   FramedSource* /*inputSource*/) {
  return SimpleRTPSink::createNew(envir(), rtpGroupsock, 33, 90000, "video", "mp2t");
}
